#include <stdio.h>
#include <sys/types.h> 
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
int main(int argc, char *argv[])
{
    int clisock;
    int portno;
    int n;
    struct sockaddr_in serv_addr;//standard structures
    struct hostent *server;
    char buffer[300];
  
    
    if (argc < 3) {
        fprintf(stderr,"usage %s hostname port\n", argv[0]);
        exit(0);
    }
    
    //getting portno from input
    portno = atoi(argv[2]);
    
    // Create a socket
    clisock = socket(AF_INET, SOCK_STREAM, 0);
    
    if (clisock < 0) 
    {
        perror("ERROR Unable to open the socket");
        exit(1);
    }
    
    //search for server
    server = gethostbyname(argv[1]);
    if (server == NULL) {
        fprintf(stderr,"ERROR, no such host\n");
        exit(0);
    }

    //initializing structure members to null
    bzero((char *) &serv_addr, sizeof(serv_addr));
    
    serv_addr.sin_family = AF_INET;
    //address family for structure socket

    //copying server details from structure
    bcopy((char *)server->h_addr, 
           (char *)&serv_addr.sin_addr.s_addr,
                server->h_length);
    

    serv_addr.sin_port = htons(portno);
    // htons is used to convert port no from host byte order to 
    // network byte order used in TCP


    // Connecting to the server using system call connect
    if (connect(clisock,&serv_addr,sizeof(serv_addr)) < 0) 
    {
         perror("ERROR Unable to connect");
         exit(1);
    }	
    

    printf("Please enter your message: ");
    bzero(buffer,300);
    
    //getting input from the client and storing it in buffer
    fgets(buffer,299,stdin);
    
    // Send message to the server 
    n = write(clisock,buffer,strlen(buffer));
    
    if (n < 0) 
    {
         perror("ERROR Unable to write to socket");
         exit(1);
    }
    
    // Reading server response
    bzero(buffer,300);
    
    n = read(clisock,buffer,299);
    
    if (n < 0) 
    {
         perror("ERROR Unable to read from server");
         exit(1);
    }
    
    printf("%s\n",buffer);
    return 0;
}
