#include <stdio.h>
#include <sys/types.h> 
#include <sys/socket.h>
#include <netinet/in.h>

int main( int argc, char *argv[] )
{
    int clisock;                   //sockfd is file descriptor
    int nwsockfd;
    int portno;                   //variable for port number
    int clen;                   //for size of client address
    char buffer[300];            
    struct sockaddr_in serv_addr;
 //standard structures for socket programming
    struct sockaddr_in cli_addr;                 
     int  n;

    // creating a socket ,using a socket call function(socket type stream socket )
 
    clisock = socket(AF_INET, SOCK_STREAM, 0);

    if (clisock < 0) 
    {
        perror("ERROR unable to open socket");   //printing error 
        exit(1);
    }

    //filling in socket structure intials

    bzero((char *) &serv_addr, sizeof(serv_addr));

    //using bzero to set all structure parameters to null
   
    portno = 5001;

    //random portno to be given

    serv_addr.sin_family = AF_INET;

    // socket input family for ip address

    serv_addr.sin_addr.s_addr = INADDR_ANY;

    serv_addr.sin_port = htons(portno);

    // htons is used to convert port no from host byte order to 

    // network byte order used in TCP

    if (bind(clisock, (struct sockaddr *) &serv_addr,
                          sizeof(serv_addr)) < 0)
    {
         perror("ERROR socket unable to bind with server address");

         exit(1);
    }

//using the function listen while using blocking socket with 
//number of blocked clients may be 5

    listen(clisock,5);

    clen = sizeof(cli_addr);//checking size of cli_addr struct

    //Using the accept function to accept the connection 

    nwsockfd = accept(clisock, (struct sockaddr *)&cli_addr, 
                                &clen);

    if (nwsockfd < 0) 
    {
        perror("ERROR unable to accept");


        exit(1);
    }
    //when connected start chatting

    bzero(buffer,300);//intializing buffer to zero

    n = read( nwsockfd,buffer,299 );

    //reading the data from buffer

    if (n < 0)
    {
        perror("ERROR Unable to read from socket");

        exit(1);
    }
    
  printf("client has messaged: %s\n",buffer);
  //printing the client message 

    //replying client

    n = write(nwsockfd,"I got your message",18);
    if (n < 0)
    {
        perror("ERROR Unable to write  socket");
        exit(1);
    }
    return 0; 
}

